<script lang="ts" setup>
import { getCurrentInstance } from 'vue'
import Column from 'primevue/column'
import DataTable from 'primevue/datatable'
import TableSkeleton from '@/components/TableSkeleton.vue'
import { useProductStore } from '@/stores/product'

const productStore = useProductStore()

const formatFeatures = (features: Array<string>) => features.join(', ')

const component = getCurrentInstance()

const selectedLicenseeId = component?.vnode.key as string ?? ''

await productStore.loadProducts(selectedLicenseeId)

</script>

<template>
  <div class="products-root">
    <TableSkeleton v-if="productStore?.isLoading" />
    <div v-if="!productStore?.isLoading && (productStore?.products?.length ?? 0 !== 0)" >
      <h2 class="pl-3 text-xl text-left">Available products</h2>
      <DataTable
          class="py-3"
          stripedRows :value="productStore.products"
          table-class="min-width: 50rem"
          data-test="table-products">
        <Column field="productName" header="Product" />
        <Column field="features" header="Enabled features">
          <template #body="slotProps">
                {{ formatFeatures(slotProps.data.features) }}
            </template>
        </Column>
      </DataTable>
    </div>
    <div v-if="!productStore?.isLoading && productStore?.products?.length === 0" >
      <h2 class="pl-3 text-xl text-left">No products available</h2>
    </div>
  </div>
</template>
